% ZOOM ARRIERE D'UNE IMAGE ET ALIASING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
close all;

u = double(imread('room.png'));
figure(1)
imagesc(u,[0,255]); colormap gray; axis image
figure(3)
vis_mod_img(u);

%% 1) Zoom arriere par sous-echantillonnage :

% Sous-echantillonnage par r:
r = 4;
v4 = u(1:r:end,1:r:end);
figure(4)
imagesc(v4,[0,255]); colormap gray; axis image
figure(6)
vis_mod_img(v4);

%%% !!! QUESTIONS !!! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Qu'observe-t-on ? 
% Comment cela se traduit-il au niveau du spectre ?
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 2) Repliement du spectre pour une onde pure :
clear all;
close all;

% Creation d'une onde pure haute frequence :
N = 512;
f1 = 250;
f2 = 124;
tfu = zeros(N);
tfu(f1+N/2+1,f2+N/2+1) = 1;
tfu(-f1+N/2+1,-f2+N/2+1) = 1;
u = real(fft2(fftshift(tfu)));
figure(3)
imagesc(u); colormap gray; axis image

% Sous-echantillonnages par 2 :
r = 2;
v2 = u(1:r:N,1:r:N);
figure(4)
imagesc(v2); colormap gray; axis image

% Sous-echantillonnage par 4 :
r = 4;
v4 = u(1:r:N,1:r:N);
figure(5)
imagesc(v4); colormap gray; axis image


%%% !!! QUESTIONS !!! %%%
% Expliquez precisement le comportement des deux ondes sous-echantillonees.
% Quelle est la frequence de l'onde de l'image sous-echantillonnee par 4 ?
%%%%%%%%%%%%%%%%%%%%%%%%%

%% 3) Zoom-arriere par coupure frequentielle.

% Pour eviter le phenomene de repliement du spectre on met a 0 les hautes
% frequences avant de sous-echantillonner.
clear all;
close all;
u = double(imread('room.png'));
figure(6)
imagesc(u,[0,255]); colormap gray; axis image

[m,n] = size(u);
tfu = fftshift(fft2(u));

% Coupure frequentielle :
r = 4;
ctfu = zeros(size(tfu));
ctfu( (m/2-m/(2*r)+1):(m/2+m/(2*r)) , (m/2-m/(2*r)+1):(m/2+m/(2*r)) ) = tfu( (m/2-m/(2*r)+1):(m/2+m/(2*r)) , (m/2-m/(2*r)+1):(m/2+m/(2*r)) );

cu = real(ifft2(fftshift(ctfu)));
figure(7)
imagesc(cu,[0,255]); colormap gray; axis image
nv4 = cu(1:r:end, 1:r:end);
figure(8)
imagesc(nv4,[0,255]); colormap gray; axis image



