% ZOOMS AVANT D'UNE IMAGE :

clear all;
close all;

% Lecture d'une image :
u2 = double(imread('lena.png'));
u = u2(60:160-1,60:160-1);

figure(1)
imagesc(u,[0,255]); colormap gray; axis image; truesize(1)
[m, n] = size(u);

% Facteur de zoom :
r = 4;

% Zoom pixel le plus proche :
method = 'nearest';
[X,Y] = meshgrid(0:n-1, 0:m-1);
[XI, YI] = meshgrid(0:1/r:n-1/r, 0:1/r:m-1/r);
v0 = interp2(X,Y,u,XI,YI,method);
figure(2)
imagesc(v0,[0,255]); colormap gray; axis image; truesize(2)

% Zoom par interpolation bilineaire :
method = 'linear';
[X,Y] = meshgrid(1:n, 1:m);
[XI, YI] = meshgrid(1:1/r:n+1-1/r, 1:1/r:m+1-1/r);
v1 = interp2(X,Y,double(u),XI,YI,method);
figure(3)
imagesc(v1,[0,255]); colormap gray; axis image; truesize(3)


% Zoom par 0-padding :
tfu = fftshift(ifft2(double(u)));
tfvf = zeros(r*size(u));
tfvf( (r*m/2-m/2+1):(r*m/2+m/2) , (r*n/2-n/2+1):(r*n/2+n/2) ) = tfu;
vf = real(fft2(fftshift(tfvf)));
figure(4)
imagesc(vf,[0,255]); colormap gray; axis image; truesize(4)

